# Choose between KDE 4 and 5.
%global plasma5 0
%global my_name plasma-addons-x2go
%if 0%{?suse_version}
%if 0%{?sle_version} >= 150300 || 0%{?suse_version} > 1550
%global plasma5 1
%global my_name plasma5-addons-x2go
%endif
%endif
%if 0%{?fedora} >= 38
%global plasma5 1
%endif

Name:           x2goplasmabindings
Summary:        Plasma widget for X2Go session control
Version:        3.0.2.3
Release:        0.0x2go1%{?dist}
%if 0%{?suse_version}
Group:          Production/Network/Remote Desktop
%else
Group:          Applications/Communications
%endif
License:        LGPL-2.0-only AND GPL-3.0-only
URL:            https://www.x2go.org
Source0:        https://code.x2go.org/releases/source/%{name}/%{name}-%{version}.tar.gz

BuildRequires:  cmake
%if 0%{?plasma5}
BuildRequires:  cmake(KF5Plasma)
BuildRequires:  cmake(KF5I18n)
BuildRequires:  cmake(Qt5)
BuildRequires:  cmake(Qt5Quick)
BuildRequires:  cmake(Qt5Core)
%if 0%{?rhel} || 0%{?fedora}
BuildRequires:  kf5-rpm-macros
%endif
%if 0%{?suse_version}
BuildRequires:  kf5umbrella
%endif
%else
%if 0%{?suse_version}
BuildRequires:  kde4-filesystem
%else
BuildRequires:  kde-filesystem
%endif
%if 0%{?rhel}
BuildRequires:  kdelibs4-devel
%else
BuildRequires:  cmake(KDeclarative)
%endif
%endif
BuildRequires:  intltool
Requires:       %{my_name}

%if 0%{?fedora} || 0%{?rhel}
# For some reason gcc doesn't depend upon redhat-rpm-config,
# but the GCC spec file is still used, which leads to gcc failing
# due to a missing annobin plugin during compilation.
# Let's build-depend upon redhat-rpm-config for now manually.
BuildRequires:  redhat-rpm-config
%endif

%if 0%{?plasma5}
# This is only really needed for directory owning.
%if 0%{?suse_version}
BuildRequires:  plasma5-desktop
Requires:       plasma5-desktop
# The dependency parser barfs on libvulkan1 vs. kinfocenter5, which requires
# /usr/bin/vulkaninfo if libvulkan1 is installed. While that is certainly a
# bug with our version of obs-build, libsolv, librpm or whatever is actually
# causing it, we should be able to easily avoid this error by masking
# kinfocenter5.
#!BuildIgnore:  kinfocenter5
%else
BuildRequires:  plasma-desktop
Requires:       plasma-desktop
%endif
%endif

BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
X2Go is a server-based computing environment with
    - session resuming
    - low bandwidth support
    - session brokerage support
    - client side mass storage mounting support
    - audio support
    - authentication by smartcard and USB stick

%if 0%{?plasma5}
This package adds a plasma widget (KDE5) for controlling your
%else
This package adds a plasma widget (KDE4) for controlling your
%endif
X2Go session.

%package -n %{my_name}
Summary:        Plasma widget for X2Go session control
Group:          Applications/Communications
Requires:       hicolor-icon-theme
Requires:       x2goserver >= 3.1.1.2
Conflicts:      plasma-widget-x2go

%description -n %{my_name}
X2Go is a server-based computing environment with
    - session resuming
    - low bandwidth support
    - session brokerage support
    - client side mass storage mounting support
    - audio support
    - authentication by smartcard and USB stick

%if 0%{?plasma5}
This package adds a plasma widget (KDE5) for controlling your
%else
This package adds a plasma widget (KDE4) for controlling your
%endif
X2Go session.

%prep
%setup -q


%build
mkdir build
cd build
cmake .. \
%if 0%{?suse_version} && 0%{?suse_version} <= 1130
        -DCMAKE_SKIP_RPATH=ON \
%endif
        -DCMAKE_INSTALL_PREFIX="%_prefix" \
        -DKDE4_PLASMA_LIBS="%_libdir/kde4" \
        -DPLUGIN_INSTALL_DIR="%_libdir/kde4" \
        -DCMAKE_C_FLAGS:STRING="%optflags" \
        -DCMAKE_CXX_FLAGS:STRING="%optflags" \
        -DCMAKE_VERBOSE_MAKEFILE:BOOL=ON \
%if 0%{?plasma5}
        '-DUSE_PLASMA5=ON'
%else
        '-DUSE_PLASMA5=OFF'
%endif
# This comment also serves as a guard in case the else branch is incorrectly
# removed without noticing the last escaped newline.
make %{?_smp_mflags}


%install
rm -rf $RPM_BUILD_ROOT
cd build
make install DESTDIR=$RPM_BUILD_ROOT


%post -n %{my_name}
/bin/touch --no-create %{_datadir}/icons/hicolor &>/dev/null || :

%postun -n %{my_name}
if [ $1 -eq 0 ] ; then
    /bin/touch --no-create %{_datadir}/icons/hicolor &>/dev/null
    /usr/bin/gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :
fi

%posttrans -n %{my_name}
/usr/bin/gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :


%files -n %{my_name}
%defattr(-,root,root)
# This will also catch %%{?suse_version} == 0 (i.e., non-SuSE), which is what
# we want. Hopefully.
%if ( ! 0%{?suse_version} ) || 0%{?suse_version} >= 1500
%license COPYING COPYING.GPL3
%else
%doc COPYING COPYING.GPL3
%endif
%doc debian/changelog
%doc debian/copyright
%if 0%{?plasma5}
%dir %{_libdir}/qt5/qml/org
%dir %{_libdir}/qt5/qml/org/x2go
%dir %{_libdir}/qt5/qml/org/x2go/plasmoid
%{_libdir}/qt5/qml/org/x2go/plasmoid/libX2GoPlasmoidPlugin.so
%{_libdir}/qt5/qml/org/x2go/plasmoid/qmldir
%{_datadir}/plasma/plasmoids/org.x2go.plasmoid
%{_datadir}/metainfo/org.x2go.plasmoid.appdata.xml
%else
%dir %{_libdir}/kde4
%{_libdir}/kde4/*
%dir %{_datadir}/kde4/services
%{_datadir}/kde4/services/*
%endif
%{_datadir}/icons/*
%{_datadir}/locale/*/LC_MESSAGES/*.mo

%changelog
